/*******************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only 
* intended for use with Renesas products. No other uses are authorized. This 
* software is owned by Renesas Electronics Corporation and is protected under
* all applicable laws, including copyright laws.
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
* THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
* LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
* AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS 
* ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE 
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
* ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
* BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software
* and to discontinue the availability of this software. By using this software,
* you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
* Copyright (C) 2018 Renesas Electronics Corporation. All rights reserved.    
*******************************************************************************/
/*******************************************************************************
* File Name    : freertos_start.h
* Version      : 1.0
* Description  : FreeRTOS's user-defined functions header file.
******************************************************************************/
/*****************************************************************************
* History : DD.MM.YYYY Version  Description
*         : 30.06.2016 1.00     First Release
******************************************************************************/

#ifndef FREERTOS_START_H_
#define FREERTOS_START_H_

/******************************************************************************
Macro definitions
******************************************************************************/
/* USB FIT module support macro */
#define RTOS_USB_SUPPORT   0

/* Interrupt vector of CMT channel used for system timer of RTOS */
#ifndef BSP_CFG_RTOS_SYSTEM_TIMER
    #error "Setting BSP_CFG_RTOS_SYSTEM_TIMER is necessary."
#elif BSP_CFG_RTOS_SYSTEM_TIMER == 0
    #define BSP_RTOS_SYSTEM_TIMER_VECTOR    _CMT0_CMI0
#elif BSP_CFG_RTOS_SYSTEM_TIMER == 1
    #define BSP_RTOS_SYSTEM_TIMER_VECTOR    _CMT1_CMI1
#elif BSP_CFG_RTOS_SYSTEM_TIMER == 2
    #define BSP_RTOS_SYSTEM_TIMER_VECTOR    _CMT2_CMI2
#elif BSP_CFG_RTOS_SYSTEM_TIMER == 3
    #define BSP_RTOS_SYSTEM_TIMER_VECTOR    _CMT3_CMI3
#else
    #error "Setting BSP_CFG_RTOS_SYSTEM_TIMER is invalid."
#endif

/******************************************************************************
Typedef definitions
******************************************************************************/

/******************************************************************************
Exported global variables
******************************************************************************/
#ifdef RENESAS_SIMULATOR_DEBUGGING
extern const uint32_t renesas_simulator_debugging_key;
#endif

/************* semaphore handler *****************/


/************* mutex handler *********************/


/************** queues handler *******************/


/************** event groups handler *************/


/************** mailbox handler ******************/


/************** memory pool handler **************/


/************** task handler *********************/


/******************************************************************************
Exported global functions (to be accessed by other files)
******************************************************************************/
extern void vPrintString(const char *pcMessage);
extern void Processing_Before_Start_Kernel(void);
extern void Kernel_Object_init(void);

extern void main_task(void *pvParameters);

#endif /* FREERTOS_START_H_ */
